/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, delegateCombine, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-react-core";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Pool$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DoubleCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
/**
 * @hidden
 */
export let CategoryBucketCalculator = /*@__PURE__*/ (() => {
    class CategoryBucketCalculator extends Base {
        constructor(a) {
            super();
            this.c = null;
            this.e = 0;
            this.f = 0;
            this.d = 0;
            if (a == null) {
                throw new ArgumentNullException(0, "view");
            }
            this.c = a;
            this.e = -1;
            this.d = 0;
        }
        getBucket(a) {
            return null;
        }
        getBucketWithoutUnknowns(a) {
            return this.getBucket(a);
        }
        getErrorBucket(a, b) {
            return NaN;
        }
        g(a) {
            let b = this.c.by;
            let c = this.c.bx;
            let d = this.c.cw;
            let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
            let f = d.c6;
            if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
                this.d = 0;
                return;
            }
            let g = d.getEffectiveViewport1(this.c);
            let h = d.to(this.c);
            let i = typeCast(ISortingAxis_$type, e);
            if (i == null || i.i$b == null) {
                let j = new ScalerParams(0, b, c, e.ch, g);
                let k = Math.floor(e.em(h.left, j));
                let l = Math.ceil(e.em(h.right, j));
                if (e.ch) {
                    l = Math.ceil(e.em(h.left, j));
                    k = Math.floor(e.em(h.right, j));
                }
                l = Math.min(l, e.lg - 1);
                let m = Math.floor((l - k + 1) * a / h.width);
                this.d = truncate(Math.max(1, m));
                this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
                this.f = truncate(Math.ceil(l / this.d));
            }
            else {
                this.e = i.i$e(b, c, g, h);
                this.f = i.i$g(b, c, g, h);
                this.d = 1;
            }
        }
        getBucketInfo(a, b, c, d) {
            a = this.e;
            b = this.f;
            c = this.d;
            d = this.c.cw.hj;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        }
        cacheValues() {
        }
        unCacheValues() {
        }
    }
    CategoryBucketCalculator.$t = /*@__PURE__*/ markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
    return CategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let CategoryFramePreparerBase = /*@__PURE__*/ (() => {
    class CategoryFramePreparerBase extends FramePreparer {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            let j = d[4];
                            super(1, g, h, i);
                            this.g = null;
                            this.h = null;
                            this.m = false;
                            this.o = new List$1(Array_$type, 0);
                            this.p = new List$1(Number_$type, 0);
                            this.n = new List$1(Number_$type, 0);
                            this.h = f;
                            this.g = j;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        super(1, d, e, f);
                        this.g = null;
                        this.h = null;
                        this.m = false;
                        this.o = new List$1(Array_$type, 0);
                        this.p = new List$1(Number_$type, 0);
                        this.n = new List$1(Number_$type, 0);
                        this.h = c;
                        this.g = g;
                    }
                    break;
            }
        }
        i(a) {
            let b = new PreparationParams();
            b.f = this.h.useHighMarkerFidelity;
            b.b = this.h.scaler;
            b.c = this.h.yScaler;
            b.d = typeCast(ISortingAxis_$type, b.b);
            b.a = typeCast(CategoryFrame.$, a);
            if (b.a == null || b.b == null || b.c == null) {
                return null;
            }
            let c;
            let d;
            let e;
            let f;
            let g = this.g.getBucketInfo(c, d, e, f);
            c = g.p0;
            d = g.p1;
            e = g.p2;
            f = g.p3;
            b.k = c;
            b.l = d;
            b.j = e;
            b.i = f;
            if (b.l < b.k) {
                return null;
            }
            let h;
            let i;
            let j;
            let k = this.a.getViewInfo(i, h);
            i = k.p0;
            h = k.p1;
            j = this.a.getEffectiveViewport();
            let l = this.a.getMainContentViewport();
            b.p = h;
            b.o = i;
            b.n = j;
            b.m = l;
            if (Rect.l_op_Equality(b.p, Rect.empty) || Rect.l_op_Equality(b.o, Rect.empty)) {
                return null;
            }
            if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.ep) && this.g != null) {
                b.e = true;
            }
            return b;
        }
        r(a, b, c, d) {
            return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
        }
        s(a) {
            return this.r(a.b, a.p, a.o, a.n);
        }
        d(a, b) {
            let c = this.i(a);
            if (c == null || this.g == null) {
                return;
            }
            c.a.f.clear();
            c.a.k.clear();
            c.a.m.clear();
            c.a.p.clear();
            c.a.i.clear();
            c.a.h.clear();
            c.a.g.clear();
            let d = this.c.shouldDisplayMarkers;
            let e = false;
            let f = this.s(c);
            let g = this.j(c);
            if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
                return;
            }
            if (c.d != null && c.d.i$a) {
                c.d.i$h();
            }
            this.g.cacheValues();
            if (this.m && c.d != null && c.d.i$b.count > 0) {
                let h = c.d.i$b._inner[c.k];
                this.z(g, h, true, c.e);
                while ((isNaN_(g.c) || isNaN_(g.d)) && c.k > 0) {
                    c.k = c.k - 1;
                    h = c.d.i$b._inner[c.k];
                    this.z(g, h, true, c.e);
                }
                let i = c.d.i$b._inner[c.l];
                this.z(g, i, true, c.e);
                while ((isNaN_(g.c) || isNaN_(g.d)) && c.l < g.e - 1) {
                    c.l = c.l + 1;
                    i = c.d.i$b._inner[c.l];
                    this.z(g, i, true, c.e);
                }
            }
            if (this.m && c.d == null) {
                let j = c.k;
                let k = this.g.getBucket(j);
                while ((isNaN_(k[1]) || isNaN_(k[2])) && c.k > 0) {
                    c.k = c.k - 1;
                    j = c.k;
                    k = this.g.getBucket(j);
                }
                let l = c.l;
                k = this.g.getBucket(l);
                while ((isNaN_(k[1]) || isNaN_(k[2])) && c.l < (intDivide(g.e, c.j))) {
                    c.l = c.l + 1;
                    l = c.l;
                    k = this.g.getBucket(l);
                }
            }
            this.w(c, g, f);
            let m = this.t(c, g, f, d, e);
            this.c.updateMarkerCount(m);
            this.v(typeCast(CategoryFrame.$, a), b);
            this.g.unCacheValues();
            return;
        }
        v(a, b) {
        }
        get q() {
            return this.o;
        }
        t(a, b, c, d, e) {
            let f = 0;
            let g = false;
            let h = null;
            let i = false;
            let j = a.d != null;
            let k = a.p;
            let l = a.o;
            let m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.lj;
            let n = a.f;
            let o = this.h.mayContainUnknowns;
            let p = this.o;
            let q = this.n;
            let r = this.p;
            p.clear();
            q.clear();
            r.clear();
            let s = this.g;
            let t = this.h.provideCollisionDetector();
            let u = 0;
            let v = a.n;
            let w = new ScalerParams(0, k, l, a.b.j$b, v);
            let x = ((() => {
                let $ret = new ScalerParams(0, k, l, a.c.j$b, v);
                $ret.b = typeCast(Series.$, this.h) !== null ? this.h.h2() : NaN;
                return $ret;
            })());
            if (j) {
                u = a.b.j$d(2, w) - a.b.j$d(1, w);
                i = this.k();
            }
            let y = a.k;
            let z = a.l;
            let aa = a.a.f;
            let ab = typeCast(IDateTimeAxis_$type, a.b);
            if (ab != null) {
                ab.StartTimeCursor();
            }
            for (let ac = y; ac <= z; ++ac) {
                let ad;
                if (!j) {
                    if (!o) {
                        ad = s.getBucketWithoutUnknowns(ac);
                    }
                    else {
                        ad = s.getBucket(ac);
                    }
                }
                else {
                    ad = ((() => { let ae = this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
                }
                let ae = !m || (m && ad[1] > 0);
                let af = ad[0];
                if (!j || !isNaN_(ad[0])) {
                    aa.add(ad);
                    if (g && i) {
                        if (h != null) {
                            aa.add(h);
                        }
                    }
                    if (d && ae) {
                        let ag = ac * a.j;
                        let ah = ag;
                        if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                            ag = a.d.i$b._inner[ag];
                        }
                        let ai = new Array(ad.length);
                        ai[0] = ad[0];
                        ai[1] = ad[1];
                        ai[2] = ad[2];
                        if (n && ag < b.e) {
                            ai = new Array(ad.length);
                            ai[0] = af;
                            this.z(b, ag, true, a.e);
                            ai[1] = b.c;
                            ai[2] = b.d;
                        }
                        p.add(ai);
                        q.add(a.a.f.count - 1);
                        r.add(ag);
                    }
                }
            }
            if (ab != null) {
                ab.ResetTimeCursor();
            }
            this.y(a, c, j, w, x, e, d);
            if (d) {
                let aj = p.count;
                let ak;
                for (let al = 0; al < aj; al++) {
                    ak = p._inner[al];
                    if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                        ++f;
                    }
                }
            }
            return f;
        }
        k() {
            if (typeCast(Series.$, this.h) !== null) {
                return this.h.d9;
            }
            return false;
        }
        f(a, b, c, d, e, f, g) {
            let h;
            f = null;
            e = false;
            let i = typeCast(CategorySeries.$, this.h);
            let j = a.o;
            let k = a.p;
            let l = a.n;
            let m = new ScalerParams(0, k, j, a.b.j$b, l);
            let n = new ScalerParams(0, k, j, a.c.j$b, l);
            let o = a.e;
            if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
                return {
                    ret: [NaN, NaN, NaN],
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            if (i != null && i.c6 != null && i.c6.count < a.d.i$b.count) {
                return {
                    ret: [NaN, NaN, NaN],
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            let p = a.d.i$b._inner[b];
            let q = a.d.i$d(p);
            let r = q;
            this.z(c, p, false, o);
            while (b < a.l) {
                p = a.d.i$b._inner[b + 1];
                r = a.d.i$d(p);
                this.z(c, p, true, o);
                if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                    if (e) {
                        let s = a.d.i$b._inner[b];
                        this.z(c, s, true, o);
                        f = [a.b.j$c(q, m), c.c, c.d];
                    }
                    break;
                }
                if (!e && this.k()) {
                    let t = a.d.i$b._inner[b];
                    this.z(c, t, true, o);
                    let u = [a.b.j$c(q, m), c.c, c.d];
                    if (!isNaN_(u[0])) {
                        if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                            if (a.d != null) {
                                u[0] = u[0] + g;
                            }
                            a.a.f.add(u);
                            e = true;
                        }
                        else {
                            break;
                        }
                    }
                }
                b++;
                this.u(c, p, o);
            }
            let v = NaN;
            if (!isNaN_(q)) {
                v = a.b.j$c(q, m);
            }
            h = this.e(v, c);
            return {
                ret: h,
                p1: b,
                p4: e,
                p5: f
            };
        }
        y(a, b, c, d, e, f, g) {
            let h = a.j;
            let i = a.a.f.count;
            let j = a.a.f;
            let k = this.o;
            let l = k.count;
            if (f) {
                let m = a.c.j$c(a.c.l7, e);
                a.c.j$f(a.a.k, 0, a.a.k.count, e);
                let n = a.a.k;
                let o = n.count;
                for (let p = 0; p < n.count; p++) {
                    n._inner[p] = Math.abs(n._inner[p] - m);
                }
            }
        }
        w(a, b, c) {
        }
    }
    CategoryFramePreparerBase.$t = /*@__PURE__*/ markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
    return CategoryFramePreparerBase;
})();
/**
 * @hidden
 */
export let CategoryFramePreparer = /*@__PURE__*/ (() => {
    class CategoryFramePreparer extends CategoryFramePreparerBase {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            let j = d[4];
                            super(1, f, g, h, i, j);
                            this.aa = new DefaultCategoryTrendlineHost();
                            this.ab = new DefaultSingleValueProvider();
                            this.ac = null;
                            this.ad = null;
                            this.ac = this.aa;
                            if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                                this.ac = typeCast(IHasCategoryTrendline_$type, f);
                            }
                            this.ad = this.ab;
                            if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                                this.ad = typeCast(IHasSingleValueCategory_$type, f);
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        super(1, c, d, e, f, g);
                        this.aa = new DefaultCategoryTrendlineHost();
                        this.ab = new DefaultSingleValueProvider();
                        this.ac = null;
                        this.ad = null;
                        this.ac = this.aa;
                        if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                            this.ac = typeCast(IHasCategoryTrendline_$type, c);
                        }
                        this.ad = this.ab;
                        if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                            this.ad = typeCast(IHasSingleValueCategory_$type, c);
                        }
                    }
                    break;
            }
        }
        l(a, b, c, d, e, f) {
            let g = b[0];
            let h = b[1];
            let i = new Rect(0, g - 5, h - 5, 11, 11);
            if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
                a.m.add({ $type: Point_$type, x: g, y: h });
                this.c.updateMarkerTemplate(e, d, f);
                return true;
            }
            return false;
        }
        j(a) {
            let b = new SingleValuesHolder();
            let c = this.ad.valueColumn;
            b.f = c;
            return b;
        }
        x(a, b, c, d, e, f) {
            if (d) {
                b[0] = b[0] + c;
            }
            else {
                b[0] = a.b.j$c(b[0], e) + c;
            }
            b[1] = a.c.j$c(b[1], f);
            if (a.j > 1 || d) {
                b[2] = a.c.j$c(b[2], f);
            }
            else {
                b[2] = b[1];
            }
        }
        y(a, b, c, d, e, f, g) {
            super.y(a, b, c, d, e, f, g);
            let h = a.j;
            let i = a.a.f.count;
            let j = a.a.f;
            let k = this.q;
            let l = k.count;
            let m = new List$1(Number_$type, 0);
            if (!c) {
                m.add(0);
            }
            let n = new List$1(Number_$type, 0);
            n.add(1);
            if (c || h > 1) {
                n.add(2);
            }
            a.b.j$e(j, m, 0, i, d);
            a.c.j$e(j, n, 0, i, e);
            for (let o = 0; o < i; o++) {
                j._inner[o][0] = j._inner[o][0] + b;
            }
            if (h == 1 && !c) {
                for (let p = 0; p < i; p++) {
                    j._inner[p][2] = j._inner[p][1];
                }
            }
            if (g) {
                a.b.j$e(k, m, 0, l, d);
                a.c.j$e(k, n, 0, l, e);
                for (let q = 0; q < l; q++) {
                    k._inner[q][0] = k._inner[q][0] + b;
                }
                if (h == 1 && !c) {
                    for (let r = 0; r < l; r++) {
                        k._inner[r][2] = k._inner[r][1];
                    }
                }
            }
        }
        w(a, b, c) {
            if (this.ac.trendLineType == 0 || this.ac.trendlinePreparer == null || this.ac.trendLinePeriod < 1) {
                return;
            }
            this.ac.trendlinePreparer.prepareLine(this.ac, a, b, c);
        }
        z(a, b, c, d) {
            let e = a;
            let f = e.f;
            let g = f.item(b);
            let h = g;
            if (d) {
                let i = this.g.getBucket(b);
                g = i[1];
                h = i[1];
            }
            if (c) {
                e.c = g;
                e.d = h;
            }
            else {
                e.a = g;
                e.b = h;
            }
        }
        u(a, b, c) {
            let d = a;
            let e = d.f;
            if (b < e.count) {
                let f;
                if (c) {
                    let g = this.g.getBucket(b);
                    f = g[1];
                }
                else {
                    f = e.item(b);
                }
                d.a = Math.min(d.a, f);
                d.b = Math.max(d.b, f);
            }
        }
        e(a, b) {
            let c = b;
            return [a, c.a, c.b];
        }
    }
    CategoryFramePreparer.$t = /*@__PURE__*/ markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
    return CategoryFramePreparer;
})();
/**
 * @hidden
 */
export let CategorySeries = /*@__PURE__*/ (() => {
    class CategorySeries extends MarkerSeries {
        cg() {
            let a = new CategorySeriesView(this);
            return a;
        }
        get v5() {
            if (this.v4 == null) {
                this.v4 = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, () => this.c9.n);
            }
            return this.v4;
        }
        ds(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.getEffectiveViewport1(this.cj);
            let f = this.vl();
            let g = new ScalerParams(1, this.cy.tn, this.tw, f.ch);
            g.c = e;
            let h = this.v6();
            let i = new ScalerParams(1, this.cy.tn, this.tw, h.ch);
            i.c = e;
            let j = this.cy.tn;
            let k = this.tw;
            let l = this.currentMode2Index;
            let m = 0;
            if (f.ce && f.cc) {
                m = f.getSeriesOffset(j, k, e, l, f.categoryMode);
            }
            a.clear();
            this.t9.ci((n) => {
                if (n._visibility == 0) {
                    let o = new SeriesPointOfInterest();
                    let p = n.n;
                    let q = n.o;
                    if (p < this.tw.left || p > this.tw.right || q < this.tw.top || q > this.tw.bottom) {
                        return;
                    }
                    if (this.isVertical) {
                        if (f.cb && !f.ce && f.categoryMode != 0) {
                            o.c = n.ak;
                        }
                        else {
                            o.c = f.em(q, g);
                        }
                        o.b = h.em(p, i);
                    }
                    else {
                        if (f.cb && !f.ce && f.categoryMode != 0) {
                            o.b = n.ak;
                        }
                        else {
                            o.b = f.em(p, g);
                        }
                        o.c = h.em(q, i);
                    }
                    o.a = n.content;
                    if (b) {
                        if (this.isVertical) {
                            if (c) {
                                o.d = this.wr(o.b, d);
                            }
                            else {
                                let r = this.ih(n);
                                if (!isNaN_(r)) {
                                    o.d = this.wr(r, d);
                                }
                                else {
                                    o.d = this.wr(o.b, d);
                                }
                            }
                        }
                        else {
                            if (c) {
                                o.d = this.wr(o.c, d);
                            }
                            else {
                                let s = this.ih(n);
                                if (!isNaN_(s)) {
                                    o.d = this.wr(s, d);
                                }
                                else {
                                    o.d = this.wr(o.c, d);
                                }
                            }
                        }
                    }
                    else {
                        o.d = f.gd(n.ak);
                    }
                    a.add(o);
                }
            });
            return true;
        }
        wr(a, b) {
            if (b >= 0) {
                return round10N(a, b).toString();
            }
            else {
                return a.toString();
            }
        }
        o0(a) {
            super.o0(a);
            this.vv = a;
        }
        preferredCategoryMode(a) {
            return 0;
        }
        get categoryAxis() {
            return this.vl();
        }
        vl() {
            return this.fetchXAxis();
        }
        v6() {
            return this.fetchYAxis();
        }
        get_dz() {
            return true;
        }
        get_fi() {
            return this.v6() != null && this.v6().ch;
        }
        get_ec() {
            return true;
        }
        constructor() {
            super();
            this.vr = null;
            this.v4 = null;
            this.v8 = false;
            this.v7 = false;
            this.assigningCategoryStyle = null;
            this.assigningCategoryMarkerStyle = null;
            this.v2 = null;
            this.v3 = null;
            this.vo = new CategoryFrame(3);
            this.vq = new CategoryFrame(3);
            this.vm = new CategoryFrame(3);
            this.vp = new CategoryFrame(3);
            this.vu = null;
            this.vy = null;
            this.vu = new CategorySeriesRenderManager();
            this.vy = new CategoryTransitionSourceFramePreparer();
            this.v8 = false;
            this.v7 = false;
            this.ab = CategorySeries.$;
        }
        ac() {
            super.ac();
            this.vv.cu.g(this.hj);
        }
        we() {
            return (this.assigningCategoryStyle != null && this.v8) || (this.bs != 1);
        }
        wf() {
            return (this.assigningCategoryMarkerStyle != null && this.v7) || (this.bs != 1);
        }
        w4(a) {
            if (this.assigningCategoryStyle != null && this.v8) {
                this.assigningCategoryStyle(this, a);
            }
        }
        w3(a) {
            if (this.assigningCategoryMarkerStyle != null && this.v7) {
                this.assigningCategoryMarkerStyle(this, a);
            }
        }
        vf(a, b) {
            return null;
        }
        nj(a, b) {
            super.nj(a, b);
            if (a) {
                this.wy(b);
            }
        }
        bm() {
            let a = super.bm();
            return a;
        }
        ob() {
            super.ob();
            let a = this.fetchXAxis();
            if (a != null) {
                a.h8(false);
            }
            let b = this.fetchYAxis();
            if (b != null) {
                b.h8(false);
            }
        }
        qn(a, b) {
            super.qn(a, b);
            this.vv.cu.g(this.hj);
            this.pp(false);
        }
        qm(a, b) {
            if (this.f9 && this.iv < 0.05 && (this.cy == null || !this.cy.ew())) {
                this.ga = true;
                this.gd = false;
                this.ft = false;
            }
            super.qm(a, b);
            this.vv.cu.g(this.hj);
            this.pp(false);
        }
        o8(a, b, c, d) {
            super.o8(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    let e = this.fetchYAxis();
                    let f = this.fetchXAxis();
                    if (c != null && d == null) {
                        this.np(f);
                        this.np(e);
                    }
                    if (c == null && d != null) {
                        this.pf(f);
                        this.pf(e);
                    }
                    this.vv.cu.g(this.hj);
                    this.pp(false);
                    break;
                case "SyncLink":
                    if (this.cr != null && this.cy != null) {
                        this.vv.cu.g(this.hj);
                    }
                    this.pp(false);
                    break;
                case "TransitionProgress":
                    this.vq.c(this.iv, this.vo, this.vm);
                    if (this.dl(this.cj)) {
                        return;
                    }
                    if (this.iv == 1) {
                        this.vm.v();
                        this.w5(this.vm, this.vv);
                        if (this.f9) {
                            this.f9 = false;
                            this.nk();
                            this.cz.r = truncate(this.id());
                            this.cz.b = this.c0;
                        }
                        if (this.gc) {
                            this.gc = false;
                            this.nk();
                            this.cz.r = truncate(this.id());
                            this.cz.b = this.c0;
                            this.oz();
                        }
                    }
                    else {
                        this.w5(this.vq, this.vv);
                    }
                    if (this.cy != null) {
                        this.cy.on(this);
                    }
                    break;
                case "ErrorBarSettings":
                    this.ol();
                    break;
                case CategorySeries.$$p[4]:
                    this.pp(false);
                    break;
                case CategorySeries.$$p[1]:
                    this.v8 = this.wa();
                    this.pp(false);
                    break;
                case CategorySeries.$$p[0]:
                    this.v7 = this.v9();
                    this.pp(false);
                    break;
            }
        }
        wa() {
            return this.wc;
        }
        v9() {
            return this.wb;
        }
        wl(a) {
            return this.hx(a, this.fetchXAxis());
        }
        get_e5() {
            return typeCast(ISortingAxis_$type, this.vl()) !== null;
        }
        as() {
            return this.vl();
        }
        ja(a) {
            return this.v5.b$d(this, a);
        }
        jr(a) {
            return this.v5.b$f(this, a);
        }
        i8(a) {
            let b = truncate(Math.round(this.hv(a)));
            return b;
        }
        hv(a) {
            return this.v5.b$c(this, a);
        }
        ay(a, b, c) {
            if (this.fc(this.bs) && !c) {
                let d = this.v1(a, b, this.v3);
                this.v3 = d;
                return d;
            }
            else {
                let e = this.vz(a, b, this.v3);
                e.e = true;
                this.v3 = e;
                return e;
            }
        }
        get_es() {
            return true;
        }
        nh() {
            super.nh();
            this.v2 = null;
            this.v3 = null;
        }
        ax(a, b, c) {
            if (this.du && this.fc(this.bs) && !c) {
                let d = this.v0(a, b, this.v2);
                this.v2 = d;
                return d;
            }
            else {
                let e = this.vz(a, b, this.v2);
                this.v2 = e;
                return e;
            }
        }
        wk() {
            return this.vv.cx.a;
        }
        v1(a, b, c) {
            if (!this.uc()) {
                return null;
            }
            let d = this.vn();
            let e = this.wk();
            return this.v5.b$b(this, e, this.wo(this.cj), this.wn(this.cj), d.f, a, b, c);
        }
        v0(a, b, c) {
            let d = this.wo(this.cj);
            let e = this.wp(this.cj);
            let f = this.wn(this.cj);
            let g = this.vn();
            return this.v5.b$a(this, g.f, d, e, f, a, b, c);
        }
        vz(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.c6 != null ? this.c6.count - 1 : 0;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        vn() {
            let a = this.vm;
            if (this.dj()) {
                if (this.cz.g) {
                    this.cz.t();
                }
                a = this.vq;
            }
            return a;
        }
        w0(a, b, c, d, e, f) {
            let g = this.bs != 1;
            this.vu.a3(this.vu.d, d.cn, a, b, c, d, e, f, true);
            this.vu.aa(this.hh);
            let h = this.vu.ax;
            let i = null;
            let j = this.c6;
            let k = null;
            if (g && this.cy != null) {
                i = this.cy.a7.getHighlightingInfo(this, j, h.o, h.n, true);
                if (this.cy.a7.isCrossSeriesHighlight(this)) {
                    k = this.cy.a7.getHighlightingInfo(this, j, h.o, h.n, true);
                }
                h.b = i;
            }
            h.f = f;
            this.w3(h);
            this.vu.y(this, i, f, g, h.m, this.cy.a7.totalHighlightingProgress);
        }
        w1(a, b, c, d, e, f) {
            let g = this.bs != 1;
            this.vu.a3(this.vu.b, d.cn, a, b, c, d, e, f, false);
            this.vu.ab(this.hh);
            let h = this.vu.ay;
            let i = null;
            let j = this.c6;
            if (g && this.cy != null) {
                i = this.cy.a7.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.w4(h);
            this.vu.z(this, i, f, g, b < 0);
        }
        gl(a, b, c) {
            let d = super.gl(a, b, c);
            d = d && this.wj(this.fetchXAxis());
            d = d && this.wj(this.fetchYAxis());
            let e = c;
            if (!c.o() || b.isEmpty || a.isEmpty || this.c6 == null) {
                d = false;
            }
            if (!d) {
                e.cu.d = 0;
            }
            return d;
        }
        wj(a) {
            if (a == null || a.bi == null) {
                return false;
            }
            let b = typeCast(CategoryAxisBase.$, a);
            if (b != null) {
                if (b.itemsSource == null) {
                    return false;
                }
                if (b.lf < 1) {
                    return false;
                }
            }
            else {
                let c = typeCast(NumericAxisBase.$, a);
                if (c != null) {
                    return c.lx != c.lw;
                }
            }
            return true;
        }
        fw() {
            return this.wd;
        }
        fx() {
            return true;
        }
        vw() {
            return 12;
        }
        nk() {
            super.nk();
            this.vo.v();
            this.vm.v();
            this.vq.v();
        }
        pq(a) {
            super.pq(a);
            this.vv.cu.g(this.hj);
            if (this.dl(this.cj)) {
                this.vm.y();
                this.vq.y();
                this.vo.y();
                return;
            }
            if (this.f0) {
                if (this.dj()) {
                    if (this.cz.g) {
                        this.cz.t();
                    }
                    this.w5(this.vq, this.vv);
                }
                else {
                    this.w5(this.vm, this.vv);
                }
                return;
            }
            if (this.fp(a)) {
                let b = this.vo;
                if (this.dj()) {
                    if (this.cz.g) {
                        this.cz.t();
                    }
                    this.vo = this.vq;
                    this.vq = b;
                }
                else {
                    this.vo = this.vm;
                    this.vm = b;
                }
                let c = false;
                this.w2(this.vm, this.vv);
                if (this.gb) {
                    this.cz.w();
                    this.cz.r = truncate(this.ie());
                    this.cz.b = this.c1 != null ? this.c1 : this.c0;
                    if (this.gc) {
                        let d = this.vq;
                        this.vq = this.vo;
                        this.vo = d;
                        c = true;
                    }
                    this.vy.s(this, this.vo, this.vm, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.vx, this.vw(), this.ct, this.cs(), runOn(this, this.wm), this.vv.bx);
                    if (this.gc) {
                        let e = this.vq;
                        this.vq = this.vo;
                        this.vo = e;
                    }
                    this.gc = false;
                }
                if (this.ge) {
                    this.cz.w();
                    this.cz.r = truncate(this.ig());
                    this.cz.b = this.c2 != null ? this.c2 : this.c0;
                    if (this.f9) {
                        let f = this.vq;
                        this.vq = this.vo;
                        this.vo = f;
                        c = true;
                    }
                    this.vy.s(this, this.vo, this.vm, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.vx, this.vw(), this.ct, this.cs(), runOn(this, this.wm), this.vv.bx);
                    let g = this.vm;
                    this.vm = this.vo;
                    this.vo = g;
                    if (this.f9) {
                        let h = this.vq;
                        this.vq = this.vo;
                        this.vo = h;
                    }
                    this.f9 = false;
                }
                this.dq = false;
                if (!c) {
                    this.nf();
                }
                this.p3();
                if (this.gb) {
                    this.ga = false;
                    this.f9 = true;
                }
                if (this.ge) {
                    this.gd = false;
                    this.gc = true;
                }
            }
            else {
                this.w2(this.vm, this.vv);
                this.w5(this.vm, this.vv);
            }
        }
        cs() {
            return 3;
        }
        cu() {
            let a = this.cs();
            switch (a) {
                case 0: return 0;
                case 1: return 1;
                case 4: return 4;
                case 2: return 2;
                case 3: return 3;
            }
            return 3;
        }
        wm() {
            if (this.isVertical) {
                return this.tw.left;
            }
            return this.tw.bottom;
        }
        wg() {
            return false;
        }
        g0() {
            let a = super.g0();
            if (this.wg()) {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "DashArray";
                    $ret.p = true;
                    $ret.x = ((() => {
                        let $ret = new DoubleCollection();
                        $ret.add(5);
                        $ret.add(5);
                        return $ret;
                    })());
                    $ret.q = true;
                    return $ret;
                })());
                a.add(b);
            }
            if (!this.wg()) {
                let c = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Brush";
                    $ret.p = true;
                    $ret.y = "ActualBrush";
                    $ret.q = true;
                    return $ret;
                })());
                c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.px));
                a.add(c);
            }
            if (!this.wg()) {
                let d = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Outline";
                    $ret.p = true;
                    $ret.y = "ActualOutline";
                    $ret.q = true;
                    return $ret;
                })());
                d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.px));
                a.add(d);
            }
            let e = ((() => {
                let $ret = new SeriesLayerPropertyOverlay();
                $ret.p = true;
                $ret.ad = "IsTransitionInEnabled";
                $ret.x = true;
                $ret.q = true;
                return $ret;
            })());
            a.add(e);
            let f = ((() => {
                let $ret = new SeriesLayerPropertyOverlay();
                $ret.p = true;
                $ret.ad = "TransitionInMode";
                $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
                $ret.q = true;
                return $ret;
            })());
            a.add(f);
            return a;
        }
        jw() {
            if (this.dj()) {
                return this.bi.vq;
            }
            else {
                return this.bi.vm;
            }
        }
        wq() {
            if (this.bi != null) {
                let a = this.bi;
                return a.wq();
            }
            let b = 0;
            let c = this.fetchXAxis();
            for (let d of fromEnum(this.cy.series)) {
                if (d == this) {
                    return b;
                }
                let e = typeCast(CategorySeries.$, d);
                if (e != null) {
                    let f = typeCast(CategoryAxisBase.$, e.fetchXAxis());
                    if (f == c && e.preferredCategoryMode(f) == 2) {
                        b++;
                    }
                }
            }
            return -1;
        }
        get GetErrorBarsXAxis() {
            return this.fetchXAxis();
        }
        get GetErrorBarsYAxis() {
            return this.fetchYAxis();
        }
        wz(a, b) {
            this.vu.a1(this, this.wf(), runOn(this, this.vf), this.wn(a), this.wo(a));
            let c = this.vu.d;
            let d = c != null;
            let e = this.vl();
            if (e == null) {
                return;
            }
            let f = this.getEffectiveViewport1(a);
            let g = new ScalerParams(0, a.by, a.bx, e.ch, f);
            let h = this.c6 == null ? 0 : this.c6.count;
            let i = a;
            let j = b.f;
            let k = i.cu.e;
            let l = i.cu.f;
            let m = i.cu.d;
            let n = k * m;
            for (let o = 0; o < a.cx.count; o++) {
                let p = a.cx.item(o);
                let q = p.content;
                if (d) {
                    let r = p.al;
                    this.w0(j, r, h, e, g, a.q);
                }
                this.vu.ac(p, q);
            }
        }
        w5(a, b) {
            this.ow();
            this.tn = a.aa;
            b.aw();
        }
        w2(a, b) {
            a.u();
        }
        wn(a) {
            return a.cu.d;
        }
        wo(a) {
            return a.cu.e;
        }
        wp(a) {
            return a.cu.f;
        }
        wy(a) {
            let b = a;
            b.cx.count = 0;
        }
        pr(a, b) {
            super.pr(a, b);
            if (!this.f8) {
                this.cj.a4(b);
                return;
            }
            let c = typeCast(CategorySeriesView.$, this.ci);
            c.cu.g(this.hj);
            this.cj.a4(b);
            if (this.dl(this.ci)) {
                return;
            }
            this.w6();
            this.f8 = false;
        }
        w6() {
            let a = typeCast(CategorySeriesView.$, this.ci);
            if (!this.f1) {
                this.w2(this.vp, a);
            }
            this.f1 = false;
            this.w5(this.vp, a);
        }
        vs(a) {
            let b = typeCast(CategorySeriesView.$, a);
            if (b != null && b.q) {
                if (b.p) {
                    return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cu);
                }
                else {
                    return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.cy.cv.o, this, b.cu);
                }
            }
            else {
                return this.vr;
            }
        }
        ao(a) {
            if (this.fetchXAxis() == a) {
                return this.fetchYAxis();
            }
            if (this.fetchYAxis() == a) {
                return this.fetchXAxis();
            }
            return null;
        }
        ag() {
            return [this.fetchXAxis(), this.fetchYAxis()];
        }
        static vg(a, b, c, d, e) {
            let f = null;
            if (b > -1 && !d.isEmpty && !c.isEmpty) {
                let g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
                let h = c.bottom + 10;
                let i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
                let j = c.top - 10;
                f = new Clipper(1, g, h, i, j, e);
            }
            return f;
        }
    }
    CategorySeries.$t = /*@__PURE__*/ markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
    CategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:wb:w7', [0, false], 'IsCustomCategoryStyleAllowed:wc:w8', [0, false], 'IsTransitionInEnabled:wd:w9', [0, false], 'TransitionInMode:vx:xa', [CategoryTransitionInMode_$type, /*@__PURE__*/ enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:wi:xb', [0, false]]);
    return CategorySeries;
})();
/**
 * @hidden
 */
export let CategorySeriesView = /*@__PURE__*/ (() => {
    class CategorySeriesView extends MarkerSeriesView {
        cy(a) {
            if (this.cz != a.t) {
                return true;
            }
            return false;
        }
        c1(a) {
            this.cz = a.t;
        }
        constructor(a) {
            super(a);
            this.cw = null;
            this.cz = 0;
            this.cu = null;
            this.cx = null;
            this.cz = -1;
            this.cw = a;
            this.cu = this.cv();
            this.cx = ((() => {
                let $ret = new Pool$1(Marker.$);
                $ret.create = runOn(this, this.b3);
                $ret.activate = runOn(this, this.cm);
                $ret.disactivate = runOn(this, this.co);
                $ret.destroy = runOn(this, this.cn);
                return $ret;
            })());
        }
        updateMarkerTemplate(a, b, c) {
            if (!this.b4.ue) {
                let d = this.cx.item(a);
                let e = d.content;
                e.item = this.e.c6.item(b);
                d.ak = b;
                d.al = c;
            }
        }
        cv() {
            return new CategoryBucketCalculator(this);
        }
        get shouldDisplayMarkers() {
            return this.cw.uc();
        }
        updateMarkerCount(a) {
            this.cx.count = a;
        }
        ci(a) {
            this.cx.c(a);
        }
        c0() {
        }
    }
    CategorySeriesView.$t = /*@__PURE__*/ markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
    return CategorySeriesView;
})();
